/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bullseye;

/**
 *
 * @author apaliani
 */
import eve.fx.BufferedGraphics;
import eve.fx.Color;
//import eve.fx.FontMetrics;
import eve.fx.Graphics;
import eve.fx.Rect;
import eve.ui.event.PenEvent;
import eve.ui.*;
import java.util.Hashtable;

public class ArcheryScores extends Control{

    int numRows, numCols, cellWidth, cellHeight, xCenter, yCenter, sequence, nMaxRadius, nFactor, indexRound;
    boolean[] visible;
    Hashtable hashClickedSector;
    Vole vole; // dart.png
    String player = "player_1_";
    Input m_nameRevalInput;

    public Label zeroLabel, nineLabel, goalLabel, totalLabel;

    Competition competition;

    public TablePhase tablePhase;

    boolean isCompound;

    public ArcheryScores(int indexRound, Competition competition, Input nameRevalInput)
    {
        this.competition = competition;
        this.indexRound = indexRound;
        this.m_nameRevalInput = nameRevalInput;
        this.vole = competition.rounds[indexRound].phases[competition.runningPhase].voles[competition.runningVole];

        tablePhase = new TablePhase(10, competition.phasesName());
        this.isCompound = competition.isCompound();
        reset();
    }

    public void setVole()
    {
        this.vole = competition.rounds[indexRound].phases[competition.runningPhase].voles[competition.runningVole];
    }

    public void reset()
    {
        numRows = 2;
        numCols = 2;
        visible = new boolean[4];
        backGround = Color.White;
        hashClickedSector = new Hashtable();

        competition.rounds[indexRound].phases[competition.runningPhase].voles[competition.runningVole].reset();
        sequence = 0;
        tablePhase.setText(competition.runningVole, competition.runningPhase, "");
        setVole();
        super.repaint();
    }

     /**
      * This method is called (usually only once) and is used
      * by the Control to calculate its preferred,minimum and maximum sizes.
      */
     @Override
     protected void calculateSizes(){
//             FontMetrics f = getFontMetrics();
//             cellWidth = f.getTextWidth("(00,00)")+4;
//             cellHeight = f.getHeight()+4;
//             preferredWidth = cellWidth*numCols;
//             preferredHeight = cellHeight*numCols;
     }
     
     /**
      Use this to determine the area of a particular cell in the control.
     **/
     public Rect getCellRect(int row, int col, Rect dest){
         if (dest == null) dest = new Rect();
         dest.x = col * cellWidth;
         dest.y = row*cellHeight;
         dest.width = cellWidth;
         dest.height = cellHeight;
         return dest;
     }

     @Override
     public void doPaint(Graphics g, Rect area){
         int minSize = 0;
         area.height = area.height - 20;
         if(area.width > area.height){
            minSize = area.height;
         }else{
            minSize = area.width;
         }

         nFactor = (minSize / 13);

         if (minSize > (nFactor * 12)){
            minSize = (nFactor * 12);
         }

         cellWidth = (minSize / 2);
         cellHeight = (minSize / 2);
         for (int r = 0; r<numRows; r++){
             for (int c = 0; c<numCols; c++){
                 String nameCell = r + "" + c;
                 if(hashClickedSector.containsKey(nameCell)){
                     boolean clicked = Boolean.valueOf(hashClickedSector.get(nameCell).toString());
                     paintCell(r,c,g, clicked);
                 }else{
                     paintCell(r,c,g, false);
                 }
             }
         }

         // bull eye
         drawTarget(g, minSize);

         paintArrows(g);

         try
         {
            competition.rounds[indexRound].rivalName = m_nameRevalInput.getText();
         }catch(Exception ex){}
     }


    public void paintArrows(Graphics g){
        Object[] arrows = vole.sortedList();
        String text = "";
        for(int i=0; i<arrows.length ; i++){
            Arrow arrow = (Arrow)arrows[i];
            arrow.drawDart(g, xCenter, yCenter);
            
            switch(i){
                case 0:
                    text = arrow.score + "";
                    break;
                case 1:
                    text = text + "," + arrow.score;
                    break;
                case 2:
                    text = text + "," + arrow.score;
                    break;
            }
            tablePhase.setText(competition.runningVole, competition.runningPhase, text);
        }

        this.totalLabel.text = competition.rounds[indexRound].getTotal() + "";
        //non invertire questo codice con la riga sopra
        this.zeroLabel.text = competition.rounds[indexRound].zero + "";
        this.nineLabel.text = competition.rounds[indexRound].nine + "";
        this.goalLabel.text = competition.rounds[indexRound].goal + "";
    }

    private Color getColor(int r){

         Color color = Color.White;
         switch(r){
             case 1:
                 color =  new Color(255, 255, 255); // white
                 break;
             case 2:
                 color =  new Color(254, 254, 254); // white
                 break;
             case 3:
                 color =  new Color(0,0,0); // black
                 break;
             case 4:
                 color =  new Color(1,1,1); // black
                 break;
             case 5:
                 color =  new Color(0,0,255); // blue
                 break;
             case 6:
                 color =  new Color(0,0,254); // blue
                 break;
             case 7:
                 color =  new Color(255, 0,0); // red
                 break;
             case 8:
                 color =  new Color(254, 0,0); // red
                 break;
             case 9:
             case 10:
             case 11:
                 color =  new Color(255,255,0); // yellow
                 break;
         }

         return color;
     }

    private void drawTarget(Graphics g, int size){
        int initSize = size;
        nMaxRadius = (nFactor * 11) / 2;
        for(int i=1; i< 12; i++){
            g.setColor(new Color(100,100,100));
            int space = (nFactor * i);
            int coord = space / 2;
            //separatore
            if(isCompound && i== 10)
            {
                g.setColor(new Color(255,255,0)); // yellow
            }

            g.drawEllipse(coord, coord, initSize - space , initSize - space);
            // riempimento            
            grawCircle(g, initSize, space + 1, (space + nFactor), i);
        }
    }

    private void grawCircle(Graphics g, int size, int from, int to, int i){
         for(int j=from+1; j< to; j++){
             g.setColor(getColor(i));
             int coord = j / 2;
             g.drawEllipse(coord, coord, size - j , size - j);
         }
     }

    private void paintCell(int row, int col, Graphics g, boolean byClick){
         boolean alwaysPaint = true;

         Rect r = new Rect();
         try{
             getCellRect(row, col, r);
             //
             BufferedGraphics bg = null;
             if (g == null){
                    bg = getGraphics(r.x, r.y, r.width, r.height);
                    if (bg == null) return;
                    g = bg.getGraphics();
             }

             if(byClick){
                g.setColor(Color.MediumBlue);
             }
             else{
                 g.setColor(getBackground());
             }

             g.fillRect(r.x, r.y, r.width, r.height);
             //
             if (alwaysPaint || visible[row*numCols+col]){
                    g.setColor(getForeground());
                    g.drawRect(r.x,r.y,r.width,r.height);
                    int nSec = (row << 1) + (col << 0) + 1;

                    // centro del cerchio
                    if(nSec == 4){
                        xCenter = r.x;
                        yCenter = r.y;
                    }
                    //String myLabel = ("settore  : " + nSec + "");
                    //g.setFont(getFont());
                    //g.drawText(myLabel,r.x+((cellWidth-w)/2),r.y);
             }
             if (bg != null) bg.release();
         }finally{
                 r.cache();
         }
     }

    @Override
    public void onPenEvent(PenEvent pen){
        if (pen.type == PenEvent.PEN_DOWN){
          
            // scrivo al massimo 3 frecce
            if(vole.arrows.size() < 3){
                int r = pen.y/cellHeight;
                int c = pen.x/cellWidth;
                if (r >= 0 && r <numRows && c >= 0 && c <numCols){

                    // settore di pertinenza
                    int nSector = (r << 1) + (c << 0) + 1;

                    visible[r*numCols+c] = !visible[r*numCols+c];
                    String nameCell = r + "" + c;
                    if(!hashClickedSector.containsKey(nameCell)){
                        hashClickedSector.put(nameCell, true);
                    }

                    Arrow arrow = new Arrow();
                    arrow.sector = nSector;
                    arrow.sequence = sequence++;
                    arrow.x = pen.x;
                    arrow.y = pen.y;
                    arrow.xCenter = xCenter;
                    arrow.yCenter = yCenter;
                    int radiusArrow = arrow.getRadius();
                    double scoreD = 0;
                    if(radiusArrow <= nMaxRadius){
                        scoreD = Math.ceil((nMaxRadius - radiusArrow)/(nFactor/2)) + 1;
                        if(isCompound && (scoreD > 9)) scoreD = scoreD -1;

                        if(scoreD > 10) scoreD = 10;
                    }
                    arrow.score = Integer.parseInt(Math.round(scoreD) + "");

                    vole.arrows.add(arrow);
                }
            }
        }
        super.onPenEvent(pen);
        super.repaint();
    }

}
