/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bullseye;

/**
 *
 * @author apaliani
 */
public class Competition {
    public String arcType = "";
    public String competitionType;
    public String sex;
    public Round[] rounds;

    public int numVole;

    public int runningVole = 0;
    public int runningPhase = 0;

    public Competition(int numRevals){
        rounds = new Round[numRevals];
    }

    public void build()
    {
        // creazione turni
        for(int i=0; i<rounds.length; i++){
            Round round = new Round(getPhasesForGame());
            round.name = getRoundName(i);
            rounds[i] = round;
        }
    }
    
    public boolean isCompound(){
        if(arcType != null) return arcType.equals("COMPOUND");
        return false;
    }

    public String[] phasesName(){
        if(rounds != null){
            if(rounds.length > 0){
                if(rounds[0].phases != null){
                    if(rounds[0].phases.length > 0){
                        String[] names = new String[rounds[0].phases.length];
                        for(int i=0; i<rounds[0].phases.length; i++){
                            names[i] = rounds[0].phases[i].name;
                        }
                        return names;
                    }
                }
            }
        }
        return null;
    }

    public String getRoundName(int index){
    
        String name = "";
        switch(index){
            case 0:
                name = "A";
                break;
            case 1:
                name = "B";
                break;
            case 2:
                name = "C";
                break;
            case 3:
                name = "D";
                break;
        }
        return name;
    }

    private Phase[] getPhasesForGame(){

        Phase[] phases = null;
        if(competitionType.equals("FITA")){
            phases = new Phase[4];
            if(sex.endsWith("F")){
                // 80 M
                Phase phase_80 = new Phase(getVolesForGame());
                phase_80.name = "80 M";
                phases[0] = phase_80;
                // 60 M
                Phase phase_60 = new Phase(getVolesForGame());
                phase_60.name = "60 M";
                phases[1] = phase_60;
                // 40 M
                Phase phase_40 = new Phase(getVolesForGame());
                phase_40.name = "40 M";
                phases[2] = phase_40;
            }else{
                // 90 M
                Phase phase_90 = new Phase(getVolesForGame());
                phase_90.name = "90 M";
                phases[0] = phase_90;
                // 70 M
                Phase phase_70 = new Phase(getVolesForGame());
                phase_70.name = "70 M";
                phases[1] = phase_70;
                // 50 M
                Phase phase_50 = new Phase(getVolesForGame());
                phase_50.name = "50 M";
                phases[2] = phase_50;
            }
            // 30 M
            Phase phase_30 = new Phase(getVolesForGame());
            phase_30.name = "30 M";
            phases[3] = phase_30;

        }else{            
            phases = new Phase[2];
            // FASE 1
            Phase phase_1 = new Phase(getVolesForGame());
            phase_1.name = "Fase 1";
            phases[0] = phase_1;
            // FASE 2
            Phase phase_2 = new Phase(getVolesForGame());
            phase_2.name = "Fase 2";
            phases[1] = phase_2;
        }
        return phases;
    }

    private Vole[] getVolesForGame(){
        numVole = 10;
        Vole[] voles = null;
        voles = new Vole[numVole];
        for(int i = 0; i< voles.length; i++){
            voles[i] = new Vole(3);
        }
        return voles;
    }

}
