/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bullseye;

import eve.ui.*;
import eve.ui.event.*;
import eve.sys.*;
import java.util.*;


/**
 *
 * @author apaliani
 */
public class FormMain extends Form{

    Button buttonExitCommand;
    Button buttonResetCommand;
    Button buttonStartPauseCommand;
    Button buttonSaveCommand;

    private Hashtable hashAction;
    private static String action;
    PanelArchery[] panelsArchery;

    Competition competition;

    PanelSettings panelSettings;

    private MultiPanel mp;
    private TabbedPanel tp;
    
    ArcheryScores controlArcheryScores;
    /**
     * @param args the command line arguments
     */

    public FormMain()
    {
         initGui();
    }

    private void initGui(){

        //Util.loadPropertiesFile();
        
        hashAction = new Hashtable();
        hashAction.put("exit", "Chiusura ...");
        hashAction.put("resetCompetition", "Azzeramento ...");
        hashAction.put("buildCompetition", "Creazione competizione ...");
        hashAction.put("startCompetition", "Avvio competizione ...");
        hashAction.put("setCompetition", "Imposta ...");
        hashAction.put("resetVole", "Cancella ...");
        hashAction.put("saveCompetition", "Salvataggio in corso ...");

        ButtonBar buttonMainBar = new ButtonBar();
        buttonExitCommand = new Button("Esci");
        buttonResetCommand = new Button("Cancella");
        buttonSaveCommand = new Button("Salva");
        buttonStartPauseCommand = new Button("Avvia");
        buttonExitCommand.setAction("exit");
        buttonResetCommand.setAction("resetCompetition");
        buttonSaveCommand.setAction("saveCompetition");
        buttonResetCommand.modify(Control.Disabled,0);
        buttonStartPauseCommand.setAction("startCompetition");
        buttonStartPauseCommand.modify(Control.Disabled,0);

        buttonMainBar.addNext(buttonStartPauseCommand);
        buttonMainBar.addNext(buttonResetCommand);
        buttonMainBar.addNext(buttonSaveCommand);
        buttonMainBar.addNext(buttonExitCommand);

   		tp = new TabbedPanel();
		mp = tp;

        panelSettings = new PanelSettings();
        panelSettings.addListener(this);
        tp.addItem(panelSettings, "Gara", "Gara");
        addLast(tp, Form.STRETCH,Form.FILL); 
        addLast(buttonMainBar, Form.DONTSTRETCH,Form.FILL);
    }

    @Override
    public boolean handleAction(String sAction){
        if(hashAction.containsKey(sAction))
        {
            String text = (String)hashAction.get(sAction);
            action = sAction;

            Handle h = doWorkInThread();

            ProgressBarForm pbf = new ProgressBarForm();
            pbf.title = text;
            pbf.maximizeOnPDA();
            pbf.setMainTask(action);
            pbf.showStop = true;
            pbf.horizontalLayout = false; //Put cancel below the bar.

            Object got = null;

            if(sAction.equals("exit") || sAction.equals("pause"))
            {
                h.start();
                got = "OK";
            }
            else
            {
                got = pbf.executeAndGetReturnValue(h);
            }

            if (got == null){
                    if (h.error != null)
                            new ReportException(h.error).execute();
                    else
                            new MessageBox("Abort action","action abort!",MessageBox.MBOK).execute();
            }else{
                    //new MessageBox("Staus","Processing: " + got, MessageBox.MBOK).execute();
            }
            return true;
        }

        return super.handleAction(action);
    }


    private void removeAllRound(){
        java.util.Iterator elements = tp.getAllSubControls();
        while(elements.hasNext()){

            Control control = (Control)elements.next();
            String text = control.getText();

            if(!text.equals("Gara") && !text.equals("")){
                tp.remove(control);
            }
        }
    }


    private void saveCompetition()
    {
        try{

            XMLFactory xml = new XMLFactory("BullsEye_" + Util.getSchortDateTimeID() + ".xml");
            xml.competitionTo(competition);
        }
        catch(Exception ex)
        {
        }
    }

    private void startCompetition()
    {
        panelSettings.setPhasesName(competition.phasesName());
        panelSettings.seqPhaseChoice.modify(0,Control.Disabled);
        panelSettings.seqVoleChoice.modify(0,Control.Disabled);
        panelSettings.setButton.modify(0,Control.Disabled);
        panelSettings.resetButton.modify(0,Control.Disabled);

        buttonStartPauseCommand.modify(Control.Disabled, 0);
        setCompetition();
        mp.select(0);
    }

    private void setCompetition(){
        competition.runningPhase = panelSettings.seqPhaseChoice.selectedIndex;
        competition.runningVole = Integer.parseInt(panelSettings.seqVoleChoice.getSelectedValue()) - 1;
        for(int i=0; i< panelsArchery.length; i++)
        {
            panelsArchery[i].controlArcheryScores.setVole();
        }
    }

    private void resetVole(){
        competition.runningPhase = panelSettings.seqPhaseChoice.selectedIndex;
        competition.runningVole = Integer.parseInt(panelSettings.seqVoleChoice.getSelectedValue()) - 1;
        for(int i=0; i< panelsArchery.length; i++)
        {
            panelsArchery[i].controlArcheryScores.reset();
        }
    }

    private void buildCompetion(){

        removeAllRound();
        int numRevals = Integer.parseInt(panelSettings.numRevalChoice.getSelectedValue());
        competition = new Competition(numRevals);
        competition.arcType = panelSettings.arcTypeChoice.getSelectedValue();
        competition.sex = panelSettings.sexChoice.getSelectedValue();
        competition.competitionType = panelSettings.typeGameChoice.getSelectedValue();
        competition.build();
        
        panelsArchery = new PanelArchery[numRevals];

        for(int i=0; i<numRevals; i++){
            addArcheryScore(i);
        }

        // enable controls
        buttonStartPauseCommand.modify(0, Control.Disabled);
        panelSettings.buildButton.modify(Control.Disabled, 0);

        // disable controls
        panelSettings.arcTypeChoice.modify(Control.Disabled, 0);
        panelSettings.sexChoice.modify(Control.Disabled, 0);
        panelSettings.typeGameChoice.modify(Control.Disabled, 0);
        panelSettings.numRevalChoice.modify(Control.Disabled, 0);

        startCompetition();
        
        repaint();
    }

    private void addArcheryScore(int index){
        PanelArchery panelArchery = new PanelArchery(index, competition);
        String nameRound = competition.getRoundName(index);
        mp.addItem(panelArchery, "Turno " + nameRound , "Turno " + nameRound);
        panelsArchery[index] = panelArchery;
    }

    public void onEvent(Event ev){
        if(ev.target instanceof MasterChoice){
            if(ev.type == DataChangeEvent.DATA_CHANGED){
                //String valueChoice = ((MasterChoice)(ev.target)).getSelectedValue();
            }
        }else{
            switch(ev.type)
            {
                case MenuEvent.SELECTED:
                    super.onEvent(ev);
                    break;

                default:
                    super.onEvent(ev); //Make sure you call this.
                    break;
            }
        }
    }

    public Handle doWorkInThread(){
        return new Task(){
                protected void doRun(){
                        try{
                                String got = doWork(this);
                                // If doSomething() returned null, then
                                // the stop() method was called on this task
                                // which set the shouldStop field to true.
                                if (got == null) set(Aborted|Stopped);
                                else succeed(got);
                        }catch(Exception e){
                                fail(e);
                        }
                }
        };
    }

    public String doWork(Handle h)throws Exception{

        if (h == null) h = new Handle();

        int max = 10;

        h.startDoing("Loading ...");
        for (int i = 0; !h.shouldStop && i<max; i++){
             try{Thread.sleep(10);}catch(InterruptedException e){}
             h.setProgress((float)(i+1)/max);
        }

        if (action.equals("exit") )
        {            
            Application.exit(0);
        }else

        //actSelection
        if (action.equals("reset") )
        {
            for(int i=0; i<panelsArchery.length; i++){
                panelsArchery[i].controlArcheryScores.reset();
            }
        }

        if (action.equals("buildCompetition") )
        {
            // crea gioco
            buildCompetion();
        }

        if (action.equals("startCompetition") )
        {
            // avvia gioco
            startCompetition();
        }

        if (action.equals("setCompetition") )
        {
            // impostazione gioco
            setCompetition();
        }

        if (action.equals("resetVole") )
        {
            // impostazione gioco
            resetVole();
        }

        if (action.equals("saveCompetition") )
        {
            // salva gioco
            saveCompetition();
        }

        if (h.shouldStop) return null;

        // Fake an error.
        //if ((int)(Math.random()*2) == 0) throw new IOException("Fake error!");
        return "Ok !";
    }

    public static void main(String[] args) {
         Application.startApplication(args);
         FormMain f = new FormMain();
         f.title = "BullsEye";
         f.execute();
         f.fullScreenOnPDA();
         Application.exit(0);
    }

}
