/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bullseye;

import eve.ui.table.*;
import eve.util.StringList;

/**
 *
 * @author apaliani
 */
public class TablePhase extends TableControl{

    public String[][] values;
    public String[] phasesNames;

    public TableModel tableModel;

    public TablePhase(int numberRows, String[] phaseNames)
	{
        this.phasesNames = phaseNames;
        
        tableModel = new TableModel()
        {            
			public int calculateRowHeight(int row)
			{
				return 15;
			}
			public int calculateColWidth(int col)
			{
				return 40;
			}

            public boolean getCellText(int row, int col, StringList dest)
			{
                if(row == -1)
                {
                    switch(col)
                    {
                        case -1:
                                dest.add("Vol");
                            break;
                        default:
                                dest.add(phasesNames[col]);
                            break;
                    }
                }else{
                   if(col == -1)
                   {
                       dest.add((row + 1) + "" );
                   }
                }

                if((col > -1) && (row > -1))
                {
                    dest.add(values[row][col]);
                }
				
				return true;
			}
		};

        tableModel.numRows = numberRows;
        tableModel.numCols = phaseNames.length;
        values = new String[tableModel.numRows][tableModel.numCols];
        setTableModel(tableModel);
		setPreferredSize((tableModel.numCols + 1) * 40,(numberRows + 1) * 15);
	}

    public void setText(int row, int col, String text)
    {
        if(values!= null) values[row][col] = text;
    }

    public String getText(int row, int col)
    {
        if(values!= null) return values[row][col];
        return "";
    }

}
