/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bullseye;

import java.io.FileWriter;
import java.util.*;
/**
 *
 * @author apaliani
 */
public class XMLFactory {

    FileWriter fileXML;
    Competition competition;

    public XMLFactory(String fileName)
    {
        try{
            fileXML = new FileWriter(fileName);
            writeString("<?xml version=\"1.0\" encoding=\"UTF-8\" ?> ");
        }catch(Exception ex)
        {
            String message = ex.getMessage();
        }
    }

    public void competitionTo(Competition from_competition)throws Exception
    {
        this.competition = from_competition;
        writeString("<Competition>");

        writeString("<Id>");
        writeString(Util.getSchortDateTimeID());
        writeString("</Id>");

        writeString("<Date>");
        writeString(Util.getDateTime());
        writeString("</Date>");

        writeString("<Rounds>");
        addRoundsNode();
        writeString("</Rounds>");

        writeString("</Competition>");
    }

    public void addRoundsNode()throws Exception
    {
        for(int i=0; i<competition.rounds.length; i++)
        {
            Round round = competition.rounds[i];
            writeString("<Round>");

            writeString("<Name>");
            writeString(round.name);
            writeString("</Name>");

            writeString("<Archery>");
            writeString(round.rivalName);
            writeString("</Archery>");

            writeString("<Scores>");

            writeString("<Totals>");
            writeString(""+round.getTotal());
            writeString("</Totals>");

            writeString("<Goals>");
            writeString(""+round.goal);
            writeString("</Goals>");

            writeString("<Nine>");
            writeString(""+round.nine);
            writeString("</Nine>");

            writeString("<Zero>");
            writeString(""+round.zero);
            writeString("</Zero>");

            writeString("</Scores>");

            writeString("<Phases>");
            addPhasesNode(round.phases);
            writeString("</Phases>");

            writeString("</Round>");
        }
    }

    public void addPhasesNode(Phase[] phases)throws Exception
    {
        for(int i =0; i<phases.length; i++)
        {
            Phase phase = phases[i];

            writeString("<Phase>");
            writeString("<Name>");
            writeString(phase.name);
            writeString("</Name>");

            writeString("<Voles>");
            addVolesNode(phase.voles);
            writeString("</Voles>");

            writeString("</Phase>");
        }
    }

    public void addVolesNode(Vole[] voles)throws Exception
    {
        for(int i=0; i<voles.length; i++)
        {
            Vole vole = voles[i];
            writeString("<Vole>");
            writeString("<Number>");
            writeString(""+(i+1));
            writeString("</Number>");
            writeString("<Arrows>");
            addArrowsNode(vole.arrows);
            writeString("</Arrows>");
            writeString("</Vole>");
        }
    }

    public void addArrowsNode(ArrayList arrows)
    {
        for(int i=0; i<arrows.size(); i++)
        {
            Arrow arrow = (Arrow)arrows.get(i);
            writeString("<Arrow>");

            writeString("<Sequence>");
            writeString(""+(arrow.sequence + 1));
            writeString("</Sequence>");

            writeString("<Score>");
            writeString(""+arrow.score);
            writeString("</Score>");

            writeString("<Sector>");
            writeString(""+arrow.sector);
            writeString("</Sector>");

            writeString("<ParamsDraw>");

            writeString("<X>");
            writeString(""+arrow.x);
            writeString("</X>");

            writeString("<Y>");
            writeString(""+arrow.y);
            writeString("</Y>");

            writeString("<XCenter>");
            writeString(""+arrow.xCenter);
            writeString("</XCenter>");

            writeString("<YCenter>");
            writeString(""+arrow.yCenter);
            writeString("</YCenter>");

            writeString("</ParamsDraw>");

            writeString("</Arrow>");
        }
        
    }

    private void writeString(String text)
    {
        try
        {
            fileXML.write(text + "\n");
            fileXML.flush();
        }
        catch(Exception ex){}
    }

}
