/*
 * Created on Mar 26, 2007
 *
 * Michael L Brereton - www.ewesoft.com
 * 
 * 
 */
package eve.ui;

/**
 * @author Michael L Brereton
 *
 */
//####################################################
public interface IApplicationHandler {

	/**
	 * This is called when a CLOSE message is sent to a mobile application.
	 * On some WinCE devices this happens when the OS wants to close applications
	 * due to memory constraints. You should not request user input, but
	 * rather save state if possible and immediately exit. 
	 * @param target the target window.
	 * @param eventFlags the flags for the CLOSE event.
	 * @return if it returns true then the Event is ignored, if it returns
	 * false then normal event processing continues.
	 */
	public boolean handleMobileAppClosing(Window target, int eventFlags);
	
}
//####################################################
