package eve.ui;

//##################################################################
public class InputForm extends ControlPopupForm{
//##################################################################

public static InputForm inputForm = new InputForm();

//==================================================================
public static void attach(Input who) {inputForm.attachTo(who);}
//==================================================================
public CellPanel editButtons = new CellPanel();
public Input input = new Input();
protected String oldText;

//==================================================================
public InputForm()
//==================================================================
{
	resizable = true;
	addLast(input).setCell(HSTRETCH);
	addLast(editButtons);
	titleCancel = getButton("X");
	titleOK = getButton("OK");
	all.add(input);
}
//==================================================================
public void make(boolean remake)
//==================================================================
{
	if (made) return;
	super.make(remake);
	modify(AlwaysRecalculateSizes,0);
	input.modify(AlwaysRecalculateSizes,0);
}
//==================================================================
public void setFor(Control client)
//==================================================================
{
	Input forWho = (Input)client;
	input.validator = forWho.validator;
	input.columns = forWho.columns;
	input.isPassword = forWho.isPassword;
	oldText = input.text = forWho.text;
	title = forWho.getPrompt();
	if (formFrame != null) formFrame.title.text = title;
	popup();
	formFrame.modify(AlwaysRecalculateSizes,0);
	formFrame.contents.modify(AlwaysRecalculateSizes,0);
	input.selectAll();
	debugFlag = true;
	Gui.takeFocus(input,ByRequest);
}
//==================================================================
public void close(int exitCode)
//==================================================================
{
	super.close(exitCode);
	if (exitCode != IDCANCEL) {
		client.text = input.text;
		((Input)client).selectAll();
		if (!input.text.equals(oldText)){
			((Input)client).updateText(true);
		}
	}
	client.repaintDataNow();
}

//##################################################################
}
//##################################################################


