package eve.ui;
import eve.fx.FormattedTextSpecs;
import eve.util.StringList;
import eve.util.mString;
/**
 * MessageArea is a static text display that can display multiple lines of text.
 * <p>
 * TextMessage inherits from MessageArea, but TextMessage can handle auto-wrapping of
 * lines.
 * @author Michael L Brereton
 *
 */
//##################################################################
public class MessageArea extends Label{
//##################################################################
protected String [] lines = null;
{
	format = new FormattedTextSpecs();
}
//==================================================================
public MessageArea(int rows,int columns) {super(rows,columns);}
public MessageArea(String text) {super(text,false);}
//==================================================================
{
	isData = true;
	alignment = anchor = CENTER;
}
//===================================================================
public void update()
//===================================================================
{
	lines = splitLines();
}

//===================================================================
public String [] splitLines()
//===================================================================
{
	if (text == null) return new String[0];
	return mString.split(text,'\n');
}
//===================================================================
public StringList getLines(StringList dest)
//===================================================================
{
	if (dest == null) dest = new StringList();
	dest.zero();
	if (lines == null) lines = splitLines();
	for (int i = 0; i<lines.length; i++)
		dest.add(lines[i]);
	return dest;
}
//===================================================================
public void setText(String txt) {text = txt; if (text == null) text = ""; lines = splitLines(); repaintNow();}
//===================================================================
/*
public void resizeTo(int w, int h)
{
	super.resizeTo(w,h);
	//new Exception().printStackTrace();
	System.out.println(Thread.currentThread()+" - Resize: "+w+", "+h);
}
*/
//##################################################################
}
//##################################################################

