package eve.ui;
import eve.fx.Point;
import eve.ui.event.PenEvent;

//##################################################################
public class PullDownMenu extends Button{
//##################################################################
{
	modify(MouseSensitive|DrawFlat|MakeMenuAtLeastAsWide|NoFocus,0);
	setBorder(BDR_NOBORDER,0);
}

private boolean activeMode = false;

public void setActiveMode(boolean on)
{
	activeMode = on;
}
protected MenuBar myBar;

//==================================================================
public PullDownMenu(String title,Menu m) {m.text = text = title; setMenu(m);}
//==================================================================
/**
 * Return the MenuBar that contains this PullDownMenu if any.
 */

public void make(boolean reMake)
{
	super.make(reMake);
	myBar = getMenuBar();
}
private MenuBar getMenuBar()
{
	for (Control c = parent; c != null; c = c.parent)
		if (c instanceof MenuBar) return (MenuBar)c;
	return null;
}
void deactivateMenu()
{
	closeMenu();
	pressState = false;
	penStatus &= ~PenIsOn;
	repaintNow();
}
public Menu getMenu()
{
	Menu m = super.getMenu();
	if (m != null) m.parentBar = myBar;
	return m;
}
public void onPenEvent(PenEvent pe)
{
	if (pe.type == pe.PEN_MOVE && activeMode){
		if (!isOnMe(pe.x,pe.y)) return;
		if (menuIsActive()) return;
		MenuBar mb = myBar;
		if (mb == null) return;
		mb.closeMenus();
		pressState = true;
		if (menuState != null){
			boolean was = menuState.fade;
			menuState.fade = false;
			startDropMenu(new Point(0,0));
			menuState.fade = was;
		}else{
			startDropMenu(new Point(0,0));
		}
		return;
	}
	boolean reset = ((pe.type == pe.PEN_DOWN) && menuIsActive());
	super.onPenEvent(pe);
	//if (reset) setFreeDragging();
	/*
	if (reset){
		penStatus |= PenIsOn;
		repaintNow();
	}
	*/
}
//===================================================================
public void doPenPress(Point p)
//===================================================================
{
	int dx = -p.x, dy = -p.y;
	if (startDropMenu(p)){
		//transferPenPress(getMenu(),dx,dy);
		setFreeDragging();
	}
}

//===================================================================
public void doAction(int how) {startDropMenu(new Point(1,1));}
//===================================================================
//===================================================================
public boolean willShowFrame(PenEvent ev)
//===================================================================
{
	if ((ev.type == ev.PEN_DOWN) && !menuIsActive()) return true;
	return super.willShowFrame(ev);
}
//##################################################################
}
//##################################################################


