package eve.ui;

import eve.fx.ISurface;
import eve.fx.Image;
import eve.fx.Rect;

//##################################################################
public class SavedScreen{
//##################################################################

	/**
	 * Set this true to disable saved screens under Menus and other pop-up frames.
	 */
public static boolean disableSavedScreens = false;

public Rect savedArea = new Rect(0,0,0,0);
public Window window;
/**
* Should create a SavedScreen by calling Gui.saveScreen(Rect area);
*
*/
//==================================================================
SavedScreen(Window w,Rect area,boolean doCapture)
//==================================================================
{
	if (!w.getSurface().canCapture() || disableSavedScreens) doCapture = false;
	savedArea.set(area);
	window = w;
	if (doCapture) capture();
}

private Image image;
private boolean actuallyCaptured = false;

//==================================================================
boolean capture()
//==================================================================
{
	if (image != null) {
		image.free();
		image = null;
	}
	ISurface ws = window.getSurface();
	if (actuallyCaptured = ws.canCapture()){
		image = new Image(savedArea.width,savedArea.height);
		ws.captureImage(image,savedArea.x,savedArea.y,savedArea.width,savedArea.height);
	}
	return true;
	//Graphics g = new Graphics(image);
	//g.copyRect(window.getSurface(),savedArea.x,savedArea.y,savedArea.width,savedArea.height,0,0);
	//g.setColor(Color.Black); g.fillRect(0,0,savedArea.width,savedArea.height);
	//g.free();
}
//==================================================================
public boolean restore()
//==================================================================
{
	if (actuallyCaptured && (image != null)) {
		ISurface ws = window.getSurface();
		ws.drawImage(image,savedArea.x,savedArea.y,savedArea.width,savedArea.height,savedArea.x,savedArea.y,savedArea.width,savedArea.height);
		image.free();
		image = null;
		return true;
		/*
		BufferedGraphics bg = window.getGraphics(savedArea.x,savedArea.y,savedArea.width,savedArea.height);
		Graphics g = bg == null ? null : bg.getGraphics();
		if (g == null){
			Gui.refreshScreen(window,savedArea);
			return true;
		}else{
			g.drawImage(image,savedArea.x,savedArea.y);
			bg.release();
			image.free();
			image = null;
			return true;
		}
		*/
	}else{
		Gui.refreshScreen(window,savedArea);
		return true;
	}
}
//==================================================================
public void free()
//==================================================================
{
	if (image != null) image.free();
	image = null;
	actuallyCaptured = false;
}
//##################################################################
}
//##################################################################

