package eve.ui;

import eve.fx.Dimension;
import eve.fx.Graphics;
import eve.fx.Point;
import eve.fx.Rect;

//##################################################################
public class ScrollableHolder extends Canvas {
//##################################################################

{
	origin = new Point(0,0);
	//modify(TakeControlEvents,0);
}
boolean first = true;
Control control;
/* @deprecated - use setClientConstraints() instead. **/
//public boolean stretchComponent = true;
/* @deprecated - use setClientConstraints() instead. **/
//public boolean shrinkComponent = false;

// This is used to indicate if clientConstraints are used.
//private boolean clientConstraintsSet = false;
/*
This should be any of the HEXPAND, HCONTRACT, VEXPAND, VCONTRACT values ORed together.
By default it is HEXPAND|VEXPAND meaning the client will be expanded bigger than
its preferred size, but will not be contracted smaller than its preferred size.
*/
private int clientConstraints = HEXPAND|VEXPAND;

public ControlIterator getSubControls(ControlIterator it)
{
	return ControlIterator.unNull(it).setForSingleControl(control);
}

/**
This returns the clientConstraints, which will be any of the HEXPAND, HCONTRACT, VEXPAND, VCONTRACT values ORed together.
By default it is HEXPAND|VEXPAND meaning the client will be expanded bigger than
its preferred size, but will not be contracted smaller than its preferred size.
*/
//===================================================================
public int getClientConstraints()
//===================================================================
{
	return this.clientConstraints;
	/*
	if (clientConstraintsSet) return this.clientConstraints;
	int clientConstraints = 0;
	//if (stretchComponent) clientConstraints |= HEXPAND|VEXPAND;
	//if (shrinkComponent) clientConstraints |= HCONTRACT|VCONTRACT;
	return clientConstraints;
	*/
}
/**
Set the clientConstraints value specifying the behavior horizontally and vertically.
@param hExpand if this is true then the client control will be expanded horizontally.
@param hContract  if this is true then the client control will be contracted horizontally.
@param vExpand  if this is true then the client control will be expanded vertically.
@param vContract  if this is true then the client control will be contracted vertically.
*/
//===================================================================
public void setClientConstraints(boolean hExpand, boolean hContract, boolean vExpand, boolean vContract)
//===================================================================
{
	int value = 0;
	if (hExpand) value |= HEXPAND;
	if (hContract) value |= HCONTRACT;
	if (vExpand) value |= VEXPAND;
	if (vContract) value |= VCONTRACT;
	setClientConstraints(value);
}
/**
Set the clientConstraints value specifying the behavior horizontally and vertically.
@param constraints any of the HEXPAND, HCONTRACT, VEXPAND, VCONTRACT values ORed together.
*/
//===================================================================
public void setClientConstraints(int constraints)
//===================================================================
{
	clientConstraints = constraints;
	//clientConstraintsSet = true;
}
//==================================================================
public ScrollableHolder(Control holding)
//==================================================================
{
	control = holding;
}
//===================================================================
public boolean needScrollBar(int which,int visible)
//===================================================================
{
	if (control == null) return false;
	//if (clientConstraintsSet)
	//if ((clientConstraints & (HCONTRACT|VCONTRACT)) == (HCONTRACT|VCONTRACT)) return false;
	if (which == Horizontal && ((clientConstraints & HCONTRACT) == HCONTRACT)) return false;
	if (which == Vertical   && ((clientConstraints & VCONTRACT) == VCONTRACT)) return false;
	if (control == null) return false;
	Dimension d = control.getPreferredSize(null);
	if (which == Horizontal) return d.width > visible;
	else return d.height > visible;
}
//===================================================================
public boolean canGo(int orientation,int direction,int position)
//===================================================================
{
	return true;
}
//===================================================================
public void dismantle(Control downTo)
//===================================================================
{
	if (this == downTo) return;
	super.dismantle(downTo);
	control = null;
}

//==================================================================
public void make(boolean remake)
//==================================================================
{
	super.make(remake);
	if (control == null) return;
	changeContents(control);
}
//==================================================================
public void changeContents(Control what)
//==================================================================
{
	origin.x = origin.y = 0;
	if (control != null) remove(control);
	add(control = what);
	//BUG HERE!!!!
	control.make(false);
	if (!first) {
		redisplay();
		resizeTo(width,height);
		/*
		Rect r = getDim(getCachedRect());
		resizeTo(r.width,r.height);
		cache(r);
		*/
		checkScrolls();
		//updateScrollServer(Horizontal);
		//updateScrollServer(Vertical);
	}
	first = false;
}
//==================================================================
public void onSetOrigin()
//==================================================================
{
	if (control != null) {
		Rect r = control.getRect();
		control.setRect(-origin.x,-origin.y,r.width,r.height);
	}
	super.onSetOrigin();
}	
//==================================================================
public void resizeTo(int w,int h)
//==================================================================
{
	super.resizeTo(w,h);
	if (control == null) return;
	Dimension r = control.getPreferredSize(getCachedDim());
	/*
	if (!clientConstraintsSet){
		if ((r.width < width) && stretchComponent) r.width = width;
		if ((r.height < height) && stretchComponent) r.height = height;
		if ((r.width > width) && shrinkComponent) r.width = width;
		if ((r.height > height) && shrinkComponent) r.height = height;
	}else{*/
		if ((r.width > width) && (clientConstraints & HCONTRACT) != 0) r.width = width;
		if ((r.height > height) && (clientConstraints & VCONTRACT) != 0) r.height = height;
		if ((r.width < width) && (clientConstraints & HEXPAND) != 0) r.width = width;
		if ((r.height < height) && (clientConstraints & VEXPAND) != 0) r.height = height;
	//}
	cache(r);
	control.setRect(-origin.x,-origin.y,r.width,r.height);
	if (virtualSize == null) virtualSize = new Rect();
	virtualSize = control.getDim(virtualSize);
}

//==================================================================
protected void calculateSizes()
//==================================================================
{
	if (control != null) {
		Dimension d = control.getPreferredSize(getCachedDim());
		preferredWidth = d.width; preferredHeight = d.height;
		cache(d);
	}
}
//==================================================================
public void doPaint(Graphics g,Rect where)
//==================================================================
{
	//new Exception().printStackTrace();
	super.doPaint(g,where);
}
//##################################################################
}
//##################################################################

