package eve.ui.filechooser;

/**
* You can use this to explicitly change the options for FileChooser views. By default,
* a new FileChooser will have the same view/sort options as the previous one. However
* if you call <b>FileChooser.setOptions(FileChooserOptions)</b> after constructing it, 
* you can set it to different values.
**/
//##################################################################
public class FileChooserOptions{
//##################################################################
public static final int VIEW_NAME_ONLY = 0x1;
public static final int VIEW_FILE_TIPS = 0x2;
public static final int VIEW_HIDDEN_FILES = 0x4;

public int viewOptions = VIEW_NAME_ONLY|VIEW_FILE_TIPS;
/**
* Use the File.LIST_BY options OR'ed with File.LIST_DESCENDING if necessary 
* for this variable. A value of 0 implies sort by name.
**/
public int sortOptions = 0;
public String mask = "*.*";
//===================================================================
public void copyFrom(FileChooserOptions other)
//===================================================================
{
	if (other == null) return;
	viewOptions = other.viewOptions;
	sortOptions = other.sortOptions;
}
//##################################################################
}
//##################################################################

