package eve.ui.launcher;
import java.io.IOException;
import java.net.ServerSocket;
import java.util.Vector;

import eve.io.File;
import eve.io.Io;
import eve.net.Net;
import eve.server.RemoteAppEntry;
import eve.ui.Application;
import eve.ui.CellPanel;
import eve.ui.MessageBox;
import eve.ui.ReportException;
import eve.ui.data.AppServer;
import eve.ui.data.Editor;
import eve.ui.data.LiveObject;
import eve.util.TextDecoder;
import eve.util.TextEncoder;

//##################################################################
public class VMApps extends LiveObject{
//##################################################################

public Vector apps = new Vector();

public String _fields = "apps";

//-------------------------------------------------------------------
protected TextEncoder encode(TextEncoder te)
//-------------------------------------------------------------------
{
	encodeFields(_fields,te,"VMApps");
	return super.encode(te);
}
//-------------------------------------------------------------------
protected TextDecoder decode(TextDecoder te)
//-------------------------------------------------------------------
{
	decodeFields(_fields,te,"VMApps");
	return super.decode(te);
}

//===================================================================
public void addToPanel(CellPanel cp,Editor ed,int options)
//===================================================================
{
}
//===================================================================
public boolean read()
//===================================================================
{
	try{
		String got = Io.getConfigInfo("Ewesoft\\EveApps");
		if (got == null) return false;
		textDecode(got);
		return true;
	}catch(Exception e){
		return false;
	}
}
//===================================================================
public synchronized boolean save()
//===================================================================
{
	try{
		Io.saveConfigInfo(textEncode(),configName,Io.SAVE_IN_FILE);
		return true;
	}catch(Exception e){
		new ReportException(e).execute();
		return false;
	}
}

static File getImageDirectory()
{
	try{
		File f = Io.getConfigFile(configName).getParentFile().getChild("Configs");
		if (!f.isDirectory()) {
			f = f.getParentFile().getChild(".EveApps");
			if (!f.isDirectory()) f.mkdirs();
		}
		return f;
	}catch(Exception e){
		return null;
	}
}
static final String configName = "Ewesoft\\EveApps";

public AppServer getAppServer(boolean forApplet)
{
	AppServer as = new AppServer();
	boolean addedOne = false;
	/*
	Object eveJar = null;
	if (forApplet)
		try{
			String got = Device.getPathToVm();
			if (got != null){
				File dir = File.getNewFile(got).getParentFile();
				if (dir != null){
					dir = dir.getChild("eve.jar");
					if (dir.exists()){
						FileStore eveJarF = new ZipFile(dir);
						eveJar = RemoteAppEntry.makeSharedFileStoreEntry(eveJarF);
						//System.out.println("eve.jar was found!");
					}
				}
			}
		}catch(Throwable t){}
	boolean useJar = true;
	*/
	boolean cantFindJar = false;
	/*
	Object shared = null;
	try{
		Object start = Io.createZippedMemoryFile();
		Io.addToZippedMemoryFile(start,"_images_/eve64.png","eve/eve64.png");
		FileStore fs = Io.completeZippedMemoryFile(start);
		shared = RemoteAppEntry.makeSharedFileStoreEntry(fs);
	}catch(Exception e){}
	*/
	for (int i = 0; i<apps.size(); i++){
		VMApp va = (VMApp)apps.get(i);
		RemoteAppEntry re = va.toRemoteAppEntry(forApplet);
		if (re == null) continue;
		if (forApplet){
			try{
				re.enableForApplet();
			}catch(IOException e){
				//e.printStackTrace();
				cantFindJar = true;
			}
		}
		/*
		if (true)
			try{
				re.fullPageHtml = 
					"<html><body>Woo hoo<img src="+
					re.makeHtmlLinkToResource("_images_/eve64.png",true)+
					"><hr><applet><hr>This is below";
			}catch(Exception e){
				e.printStackTrace();
			}
		*/
		/*
		if (useJar){
			if (eveJar != null) re.directories.add(eveJar);
		}else{
			re.directories.add(new File("c:\\projects\\eve\\java_eve_classes"));
			re.directories.add(new File("c:\\projects\\eve\\classes"));
		}
		*/
		as.addApplication(re);
		addedOne = true;
	}
	if (!addedOne) return null;
	return as;
}

private ServerSocket[] runningAppServer;

private void reportServer()
{
	ServerSocket[] ss = runningAppServer;
	new MessageBox("App Server Running","The App Server is running.\nHost: "+
			Net.toHostAddresses(Net.getLocalAddress(ss[0]))
			+"\nApp Port: "+ss[0].getLocalPort()+"\nHttp Port:"+ss[1].getLocalPort(),MessageBox.MBOK).execute();
}
public boolean runAppServer()
{
	if (runningAppServer != null){
		reportServer();
		return true;
	}
	AppServer as = getAppServer(false);
	if (as == null){
		new MessageBox("Cannot Share Apps","There are no Apps that can be shared.",MessageBox.MBOK).execute();
		return false;
	}
	AppServer appletServer = getAppServer(true);
	ServerSocket[] ss = as.runServer(appletServer);
	if (ss == null) return false;
	runningAppServer = ss;
	reportServer();
	return true;
}
public static void main(String[] args)
{
	Application.startApplication(args);
	try{
		VMApps apps = new VMApps();
		apps.read();
		apps.runAppServer();
	}catch(Exception e){
		new ReportException(e).execute();
	}
	Application.exit(0);
}
//##################################################################
}
//##################################################################

